import { basename } from '../../util/path.js';
import { timerify } from '../../util/Performance.js';
import { hasDependency, load } from '../../util/plugin.js';
export const NAME = 'Commitizen';
export const ENABLERS = ['commitizen'];
export const PACKAGE_JSON_PATH = 'config.commitizen';
export const isEnabled = ({ dependencies }) => hasDependency(dependencies, ENABLERS);
export const CONFIG_FILE_PATTERNS = ['.czrc', '.cz.json', 'package.json'];
const findPluginDependencies = async (configFilePath, { manifest, isProduction }) => {
    if (isProduction)
        return [];
    const localConfig = basename(configFilePath) === 'package.json' ? manifest.config?.commitizen : await load(configFilePath);
    if (!localConfig)
        return [];
    return localConfig.path ? [localConfig.path] : [];
};
export const findDependencies = timerify(findPluginDependencies);
