import { basename } from '../../util/path.js';
import { timerify } from '../../util/Performance.js';
import { hasDependency, load } from '../../util/plugin.js';
export const NAME = 'commitlint';
export const ENABLERS = ['@commitlint/cli'];
export const isEnabled = ({ dependencies }) => hasDependency(dependencies, ENABLERS);
export const CONFIG_FILE_PATTERNS = [
    '.commitlintrc',
    '.commitlintrc.{json,yaml,yml,js,cjs,ts,cts}',
    'commitlint.config.{js,cjs,ts,cts}',
    'package.json',
];
const findCommitLintDependencies = async (configFilePath, { manifest, isProduction }) => {
    if (isProduction)
        return [];
    const localConfig = basename(configFilePath) === 'package.json' ? manifest.commitlint : await load(configFilePath);
    if (!localConfig)
        return [];
    return localConfig.extends ? [localConfig.extends].flat() : [];
};
export const findDependencies = timerify(findCommitLintDependencies);
