import { basename } from '../../util/path.js';
import { timerify } from '../../util/Performance.js';
import { hasDependency, load } from '../../util/plugin.js';
export const NAME = 'npm-package-json-lint';
export const ENABLERS = ['npm-package-json-lint'];
export const PACKAGE_JSON_PATH = 'npmpackagejsonlint';
export const isEnabled = ({ dependencies }) => hasDependency(dependencies, ENABLERS);
export const CONFIG_FILE_PATTERNS = ['.npmpackagejsonlintrc.json', 'npmpackagejsonlint.config.js', 'package.json'];
const findNpmPkgJsonLintConfigDependencies = async (configFilePath, options) => {
    const { manifest, isProduction } = options;
    if (isProduction)
        return [];
    const localConfig = basename(configFilePath) === 'package.json' ? manifest[PACKAGE_JSON_PATH] : await load(configFilePath);
    return localConfig?.extends ? [localConfig.extends] : [];
};
export const findDependencies = timerify(findNpmPkgJsonLintConfigDependencies);
