import { basename } from '../../util/path.js';
import { timerify } from '../../util/Performance.js';
import { hasDependency, load } from '../../util/plugin.js';
export const NAME = 'Prettier';
export const ENABLERS = ['prettier'];
export const isEnabled = ({ dependencies, config }) => hasDependency(dependencies, ENABLERS) || 'prettier' in config;
export const CONFIG_FILE_PATTERNS = [
    '.prettierrc',
    '.prettierrc.{json,js,cjs,mjs,yml,yaml}',
    'prettier.config.{js,cjs,mjs}',
    'package.json',
];
const findPrettierDependencies = async (configFilePath, { manifest, isProduction }) => {
    if (isProduction)
        return [];
    const localConfig = basename(configFilePath) === 'package.json' ? manifest.prettier : await load(configFilePath);
    if (typeof localConfig === 'string') {
        return [localConfig];
    }
    return localConfig && Array.isArray(localConfig.plugins)
        ? localConfig.plugins.filter((plugin) => typeof plugin === 'string')
        : [];
};
export const findDependencies = timerify(findPrettierDependencies);
