import { basename } from '../../util/path.js';
import { timerify } from '../../util/Performance.js';
import { hasDependency, load } from '../../util/plugin.js';
export const NAME = 'TypeDoc';
export const ENABLERS = ['typedoc'];
export const PACKAGE_JSON_PATH = 'typedocOptions';
export const isEnabled = ({ dependencies }) => hasDependency(dependencies, ENABLERS);
export const CONFIG_FILE_PATTERNS = [
    'typedoc.{js,cjs,json,jsonc}',
    'typedoc.config.{js,cjs}',
    '.config/typedoc.{js,cjs,json,jsonc}',
    '.config/typedoc.config.{js,cjs}',
    'package.json',
    'tsconfig.json',
];
const findTypeDocDependencies = async (configFilePath, options) => {
    const { manifest, isProduction } = options;
    if (isProduction)
        return [];
    const localConfig = basename(configFilePath) === 'package.json'
        ? manifest[PACKAGE_JSON_PATH]
        : basename(configFilePath) === 'tsconfig.json'
            ? (await load(configFilePath)).typedocOptions
            : await load(configFilePath);
    return localConfig?.plugin ?? [];
};
export const findDependencies = timerify(findTypeDocDependencies);
