import { timerify } from '../../util/Performance.js';
import { getDependenciesFromScripts, hasDependency } from '../../util/plugin.js';
export const NAME = 'Wireit';
export const ENABLERS = ['wireit'];
export const isEnabled = ({ dependencies }) => hasDependency(dependencies, ENABLERS);
export const CONFIG_FILE_PATTERNS = ['package.json'];
export const ENTRY_FILE_PATTERNS = [];
export const PRODUCTION_ENTRY_FILE_PATTERNS = [];
export const PROJECT_FILE_PATTERNS = [];
export const PACKAGE_JSON_PATH = 'wireit';
const findWireItDependencies = async (_configFilePath, options) => {
    const { cwd, manifest, isProduction } = options;
    if (isProduction)
        return [];
    const localConfig = manifest[PACKAGE_JSON_PATH];
    if (!localConfig)
        return [];
    const scripts = Object.values(localConfig).flatMap(({ command: script }) => (script ? [script] : []));
    const scriptDependencies = getDependenciesFromScripts(scripts, { cwd, manifest });
    return scriptDependencies;
};
export const findDependencies = timerify(findWireItDependencies);
